/****************************************************************
This do file makes Figure 1 in Hastings, Hortacsu and Syverson
ECMA 2017. 
*****************************************************************/

********  STEP 0: SET GLOBALS **********************
	
	global root "/data/hastings2/CompletedPapers/HHS_ECMA_2017/_final/"
        global infile "${root}input/"
	global tempfile "${root}temp/"
	global outfile "${root}output/"
	global dir_log "${root}output/log/"		

	
	global date "20170206"

cap log close
log using "${dir_log}Step4_Figure1_final_${date}.txt", replace

*****************************************************

*** FIGURE 1: DISTRIBUTION OF SALES FORCE ACROSS AFORES AND OVER TIME ***

use ${infile}AgentePanel_ByYearMonth, clear

**** Label variables ****
  label var AforeAPs510	"Genesis Metropolitan"
  label var AforeAPs512	"Zurich"
  label var AforeAPs514	"Tepeyac"
  label var AforeAPs516	"XXI"
  label var AforeAPs530	"Banorte Generali"
  label var AforeAPs532	"Bancrecer/Dresdner/HSBC"
  label var AforeAPs534	"Profuturo GNP"
  label var AforeAPs536	"Atlantico Promex"
  label var AforeAPs538	"Principal"
  label var AforeAPs540	"Santander"
  label var AforeAPs542	"Previnter"
  label var AforeAPs544	"ING/Bital"
  label var AforeAPs546	"Capitaliza"
  label var AforeAPs548	"Garante"
  label var AforeAPs550	"Inbursa"
  label var AforeAPs552	"Banamex"
  label var AforeAPs554	"Bancomer"
  label var AforeAPs556	"Azteca"
  label var AforeAPs558	"Actinver"
  label var AforeAPs560	"IXE"
  label var AforeAPs562	"Invercap"
  label var AforeAPs564	"MetLife"
  label var AforeAPs566	"Afirme"
  label var AforeAPs568 "Coppel"
  label var AforeAPs570 "De la Gente"
  label var AforeAPs572	"Ahorra Ahora"
  label var AforeAPs574	"Scotia"
  label var AforeAPs576	"Argos"
  label var TotalAPs "All Afores"
  
  **Format year month variable
  tostring yearmonth, gen(temp)
  gen tyear=substr(temp,1,4)
  gen tmon=substr(temp,5,2)
  destring tyear tmon, replace
  gen date=ym(tyear,tmon)
  format date %tmMon_YY
  drop tyear tmon temp
    
  **Drop obs after end of 2000
  drop if yearmonth>200012
  lab var date " "
    
    
  ***CHANGE TO MISSING FOR DATES AFTER SOME AFORES EXITED THE MARKET***
  replace AforeAPs546=. if date>=tm(1998 Dec)		/*Capitaliza was acquired by Inbursa*/
  replace AforeAPs542=. if date>=tm(1998 Oct)		/*Previnter*/
  replace AforeAPs536=. if date>=tm(1998 Nov)		/*Atlantico Promex*/
  replace AforeAPs510=. if date>=tm(1999 Sep)		/*Genesis Metropolitan*/ 
    

  ***GROUP AFORES IN ORDER OF DESCENDING MARKET SHARE AND CALCULATE MEAN AND MAX ***       
  forvalues i=546(2)576 {
	replace AforeAPs`i'=0 if AforeAPs`i'==.
        	}
        	
  egen meanAPs=rowmean( AforeAPs546-AforeAPs576)
  egen maxAPs=rowmax (AforeAPs546-AforeAPs576)
        
  label var meanAPs "Mean Sales Force"
  label var maxAPs "Largest Sales Force"
        
  ***GRAPH FIGURE 1 ******       
  graph twoway (line TotalAPs date, lcolor(blue) lpattern(solid))(line maxAPs date, lcolor(maroon) lpattern(longdash) yaxis(2)), ///
  	xlabel(449(4)491, angle(45) labsize(small)) ylabel(0(10000)100000, angle(0) labsize(small)) ylabel(0(2000)14000, axis(2) angle(0) labsize(small)) 
  	
  graph export "${outfile}tablesFigures/FigureI.png", replace
  
  
  cap log close
  
  	
