

%%% Addendum Script: This script uses the equilbrium fees displayed in
%%% tables 11-15 (counterfactuals tables) and creates matrices of cost by
%%% demographics.


clc

global dirname dirname_pre dirname_output flowcap balcap gridsize ns matsize

ns= 121719; 
cd(dirname)
demo_id = importdata('incumbents_demogs_20170206.txt');

%% Table 11: Counterfactuals with a Govt player
cd(dirname_output)
Table11 = importdata('Table11.csv');
cd(dirname)
%%% Baseline equilibrium = Model1 = low caps, base adv, base sens, base govt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[temp_cost, temp_share] = expected_costmatrix(Table11(1:17,1),...
    Table11(1:17,2),ns,1,1);
cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage0 = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage0 = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old0 =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young0 = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male0 =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem0 = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

basecostbydemo = [low_wage0;high_wage0;fem0;male0;young0;old0];
%%% Government and Base
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[temp_cost, temp_share] = expected_costmatrix(Table11(1:17,4),...
    Table11(1:17,5),ns,1,1);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage1 = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage1 = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old1 =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young1 = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male1 =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem1 = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

%%% Government and Neutral Adv
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[temp_cost, temp_share] = expected_costmatrix(Table11(1:17,8),...
    Table11(1:17,9),ns,2,1);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage2 = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage2 = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old2 =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young2 = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male2 =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem2 = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

basecostbydemo = [low_wage0;high_wage0;fem0;male0;young0;old0];
cost_counter1 = [low_wage1;high_wage1;fem1;male1;young1;old1];  
cost_counter2 = [low_wage2;high_wage2;fem2;male2;young2;old2];

pctchng_c1=((cost_counter1 - basecostbydemo)./basecostbydemo);
pctchng_c2=((cost_counter2 - basecostbydemo)./basecostbydemo);


%%%%%%%%%%% Table 12 Counterfactuals: Elastic Investors and Base Adv
%%%%%%%%%%% 
cd(dirname_output)
Table12 = importdata('Table12.csv');
cd(dirname)
%%% Sensetivity Inc and Base   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[temp_cost, temp_share] = expected_costmatrix(Table12(1:17,4),...
    Table12(1:17,5),ns,1,2);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage3 = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage3 = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old3 =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young3 = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male3 =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem3 = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

%%% Sensetivity Inc and Neutral
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[temp_cost, temp_share] = expected_costmatrix(Table12(1:17,8),...
    Table12(1:17,9),ns,2,2);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage4 = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage4 = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old4 =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young4 = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male4 =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem4 = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

cost_counter3 = [low_wage3;high_wage3;fem3;male3;young3;old3];  
cost_counter4 = [low_wage4;high_wage4;fem4;male4;young4;old4];

pctchng_c3=((cost_counter3 - basecostbydemo)./basecostbydemo);
pctchng_c4=((cost_counter4 - basecostbydemo)./basecostbydemo);


%%% Table 13 Combined counterfactuals
cd(dirname_output)
Table13 = importdata('Table13.csv');
cd(dirname)

[temp_cost, temp_share] = expected_costmatrix(Table13(1:17,4),...
    Table13(1:17,5),ns,2,2);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage5 = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage5 = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old5 =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young5 = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male5 =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem5 = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

cost_counter5 = [low_wage5;high_wage5;fem5;male5;young5;old5];
pctchng_c5=((cost_counter5 - basecostbydemo)./basecostbydemo);

cd(dirname_output)
Table14 = importdata('Table_addendum.csv');
cd(dirname)

[temp_cost, temp_share] = expected_costmatrix(Table14(1:17,4),...
    Table14(1:17,5),ns,2,1);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage6 = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage6 = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old6 =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young6 = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male6 =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem6 = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

cost_counter6 = [low_wage6;high_wage6;fem6;male6;young6;old6];
pctchng_c6=((cost_counter6 - basecostbydemo)./basecostbydemo);

cd(dirname_output)
Table16 = importdata('Table_extra_1213.csv');
cd(dirname)

[temp_cost, temp_share] = expected_costmatrix(Table16(1:17,4),...
    Table16(1:17,5),ns,1,2);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage7 = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage7 = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old7 =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young7 = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male7 =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem7 = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

cost_counter7 = [low_wage7;high_wage7;fem7;male7;young7;old7];
pctchng_c7=((cost_counter7 - basecostbydemo)./basecostbydemo);


%% Table 14: Increase in cap with baseline + Govt Comp
cd(dirname_output)
Table14 = importdata('Table14.csv');
cd(dirname)

%% cap 1 -- Model2 = low caps, base adv, base sens, govt comp in Table 14
[temp_cost, temp_share] = expected_costmatrix(Table14(1:17,4),...
    Table14(1:17,5),ns,1,1);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage1a = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage1a = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old1a =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young1a = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male1a =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem1a = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

%% cap 2 -- Model8 = caps(3.2,5), base adv, base sens, govt comp in Table 14
[temp_cost, temp_share] = expected_costmatrix(Table14(1:17,8),...
    Table14(1:17,9),ns,1,1);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage1b = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage1b = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old1b =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young1b = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male1b =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem1b = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));


%% cap 3 -- Model9 = caps(3.2,10), base adv, base sens, govt comp in Table 14
[temp_cost, temp_share] = expected_costmatrix(Table14(1:17,12),...
    Table14(1:17,13),ns,1,1);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage1c = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage1c = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old1c =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young1c = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male1c =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem1c = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));


cost_counter1a = [low_wage1a;high_wage1a;fem1a;male1a;young1a;old1a];
pctchng_c1a=((cost_counter1a - basecostbydemo)./basecostbydemo);

cost_counter1b = [low_wage1b;high_wage1b;fem1b;male1b;young1b;old1b];
pctchng_c1b=((cost_counter1b - basecostbydemo)./basecostbydemo);

cost_counter1c = [low_wage1c;high_wage1c;fem1c;male1c;young1c;old1c];
pctchng_c1c=((cost_counter1c - basecostbydemo)./basecostbydemo);

%%  Table 15: Increase in cap with neutral + Govt Comp
cd(dirname_output)
Table15 = importdata('Table15.csv');
cd(dirname)

%% cap 1 -- Model2 = low caps, base adv, base sens, govt comp in Table 14
[temp_cost, temp_share] = expected_costmatrix(Table15(1:17,4),...
    Table15(1:17,5),ns,2,1);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage2a = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage2a = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old2a =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young2a = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male2a =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem2a = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));

%% cap 2 -- Model11 = caps(3.2,5), neutral adv, base sens, govt comp in Table 14

[temp_cost, temp_share] = expected_costmatrix(Table15(1:17,8),...
    Table15(1:17,9),ns,2,1);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage2b = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage2b = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old2b =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young2b = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male2b =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem2b = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));


%% cap 3 -- Model12 = caps(3.2,10), neutral adv, base sens, govt comp in Table 14
[temp_cost, temp_share] = expected_costmatrix(Table15(1:17,12),...
    Table15(1:17,13),ns,2,1);

cost = temp_cost(1:80229,:);
share = temp_share(1:80229,:);

high_wage2c = sum(sum(share.*cost.*repmat( demo_id(:,1),1,17),1));
low_wage2c = sum(sum(share.*cost.*repmat( 1- demo_id(:,1),1,17),1));

old2c =sum(sum(share.*cost.*repmat( demo_id(:,2),1,17),1));
young2c = sum(sum(share.*cost.*repmat( 1- demo_id(:,2),1,17),1));

male2c =sum(sum(share.*cost.*repmat( demo_id(:,3),1,17),1));
fem2c = sum(sum(share.*cost.*repmat( 1- demo_id(:,3),1,17),1));


cost_counter2a = [low_wage2a;high_wage2a;fem2a;male2a;young2a;old2a];
pctchng_c2a=((cost_counter2a - basecostbydemo)./basecostbydemo);

cost_counter2b = [low_wage2b;high_wage2b;fem2b;male2b;young2b;old2b];
pctchng_c2b=((cost_counter2b - basecostbydemo)./basecostbydemo);

cost_counter2c = [low_wage2c;high_wage2c;fem2c;male2c;young2c;old2c];
pctchng_c2c=((cost_counter2c - basecostbydemo)./basecostbydemo);


%% Create tables 

% Notes for reformatting the new tables
% basecostbydemo is the expected cost for the base model
% cost_counter`x' is the calculated expected costin counterfactual `x''
% pctchng_c`x' is the percentage change in cost from the base model in counterfact `x'



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Create tables for main table 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Notes on counterfactual numbers
% 1 - Govt Competitive 
% 2 - Govt Comp + Neutral Agentes
% 3 - Inc Price Sens 
% 4 - Inc Price Sens + Neutral
% 5 - Combined counterfactuals
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% Count sample size for each demographic bin

no_high = sum(squeeze(demo_id(:,1)));
no_low  = 80229 - no_high;

no_male = sum(squeeze(demo_id(:,2)));
no_fem  = 80229 - no_male;

no_old = sum(squeeze(demo_id(:,3)));
no_young = 80229 - no_old;

%% Take the computed cost and percent change and group them 

costbydemotable1 = [ basecostbydemo/1000000, ...
    cost_counter1/1000000, pctchng_c1*100, ...
    cost_counter2/1000000, pctchng_c2*100] ;

 costbydemotable2= [basecostbydemo/1000000, ...
    cost_counter3/1000000, pctchng_c3*100, ...
    cost_counter4/1000000, pctchng_c4*100, ...
    cost_counter5/1000000, pctchng_c5*100, ...
    cost_counter6/1000000, pctchng_c6*100, ...
    cost_counter7/1000000, pctchng_c7*100];

counts = [no_low; no_high; no_fem; no_male; no_young; no_old];

costbydemotable1 = [counts, costbydemotable1 ];

costbydemotable2 = [counts, costbydemotable2 ];


header1 = {'samplesize','base', 'cont1c','cont1d','cont2c','cont2d'};

header2 = {'samplesize','base', ...
    'cont3c','cont3d','cont4c','cont4d','cont5c','cont5d','cont6c',...
    'cont6d','cont7c','cont7d'};

group = {'Group'; 'Low wage';'High wage';'Female';'Male';'Young';'Old'};

table1 = [group, [header1; num2cell(costbydemotable1)]];

table2 = [group, [header2; num2cell(costbydemotable2)]];


cell2csv(strcat(dirname_output,'/costbydemotable1.csv'),table1);

cell2csv(strcat(dirname_output,'/costbydemotable2_updated.csv'),table2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Increased cap + govt competitive firm counterfactuals 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

costbydemotable_app1 = [ basecostbydemo/1000000, ...
    cost_counter1a/1000000, pctchng_c1a*100, ...
    cost_counter1b/1000000, pctchng_c1b*100, ...
    cost_counter1c/1000000, pctchng_c1c*100];


costbydemotable_app2 = [ basecostbydemo/1000000, ...
    cost_counter2a/1000000, pctchng_c2a*100, ...
    cost_counter2b/1000000, pctchng_c2b*100, ...
    cost_counter2c/1000000, pctchng_c2c*100];

costbydemotable_app1 = [counts, costbydemotable_app1 ];

costbydemotable_app2 = [counts, costbydemotable_app2 ];

header_app = {'samplesize','base', 'cont1c','cont1d','cont2c','cont2d',...
    'cont3c','cont3d'};

table_app1 = [group, [header_app; num2cell(costbydemotable_app1)]];

table_app2 = [group, [header_app; num2cell(costbydemotable_app2)]];


% Baseline

cell2csv(strcat(dirname_output,'/costbydemotable1_app.csv'),table_app1);

% Neutral Agentes
cell2csv(strcat(dirname_output,'/costbydemotable2_app.csv'),table_app2);





