% Script: This file loads the data and consolidates it in a matlab
% file called newdata.mat


% Load the original data
load('fees.mat')
load('file_matlab_contfact_20170206.txt')
data=file_matlab_contfact_20170206;


% Prepare matlab dataset
capped_salary=zeros(80229,10);
cs = zeros(80229,10);
betas_conterfact = zeros(80229,19);
betas_real = zeros(80229,19);


% Fill in matrices
sar92sum = data(:,1);

for j=1:10
    capped_salary(:,j)=data(:,2*j);
    cs(:,j)=data(:,2*j+1);
end

yrs_to_ret = data(:,23);
wage = data(:,24);
male = data(:,49);
age = data(:,48);
betas_real(:,1) = data(:,26);
betas_real(:,2) = data(:,27);

betas_conterfact(:,1) = data(:,28);
betas_conterfact(:,2) = data(:,27);

for j=1:17
    
    betas_real(:,2+j)=data(:,49+j);
    betas_conterfact(:,2+j) = data(:,28+j);
    
end


% Add incumbent workers

load ('newentrants_age_20170206.txt')
load ('newentrants_betascounterfactual_20170206.txt')
load ('newentrants_betasreal_20170206.txt')
load ('newentrants_cappedexpsalary_20170206.txt')
load ('newentrants_cs_20170206.txt')
load ('newentrants_male_20170206.txt')
load ('newentrants_sar92sum_20170206.txt')
load ('newentrants_wage_20170206.txt')
load ('newentrants_yrstoret_20170206.txt')


age = [age; newentrants_age_20170206] ;
betas_conterfact = [ betas_conterfact;...
    newentrants_betascounterfactual_20170206];
betas_real = [betas_real; newentrants_betasreal_20170206];
capped_salary= [capped_salary; newentrants_cappedexpsalary_20170206];
cs = [cs; newentrants_cs_20170206];
male = [male ; newentrants_male_20170206];
sar92sum = [sar92sum; newentrants_sar92sum_20170206];
wage = [ wage; newentrants_wage_20170206];
yrs_to_ret = [yrs_to_ret; newentrants_yrstoret_20170206];


clearvars data file_matlab_contfact_20170206

% Create parameter matrix 

betas_m=zeros(121719,19,2);
betas_m(:,:,1)=betas_real;
betas_m(:,:,2)=betas_conterfact;

% Change cs variable since matlab considers this as a function
cs_alt=cs;

clear cs


save newdata.mat
