%% This do file creates the graphs 

clc
clear all  
  
load newdata.mat;


delta=[0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 -.05 -.05 -.05 -.05 -.05 -.05 -.05 -.05 -.05;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 -0.02 -0.02 -0.02 -0.02 -0.02;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 0 0 0 0 0;
       0 0 0 0 0 -0.02 -0.02 -0.02 -0.02 -0.02;
       0 -0.02 -0.01 -0.01 -0.01 -0.01 -0.01 0 0 0];

   
delta=delta/100;
nj = size(delta,1);
betas=betas_real;
m=4; % Choose which firm's profit function you'd like to plot; 4 = Afore XXI
pre_size=size(betas,1)

%% Cut the sample size
rndsamp=randi(floor(pre_size*.25),[1,pre_size]);

 capped_salary=capped_salary(rndsamp,:);
 betas=betas(rndsamp,:);
 wage=wage(rndsamp,:);
 cs_alt=cs_alt(rndsamp,:);
 age=age(rndsamp,:);
 yrs_to_ret=yrs_to_ret(rndsamp,:);
 sar92sum=sar92sum(rndsamp,:);
%%%%%

% choose price sensitivity counterfactual

lambda_temp = betas(:,1) + betas(:,2).*wage; % ns vector of lambda_i
%lambda      = betas(:,1) + betas(:,2).*wage; % ns vector of lambda_i
sens = 2
if sens==1 
    
    lambda   = lambda_temp  ; % ns vector of lambda_i

else

    lambda   = lambda_temp ...
        -std(lambda_temp).*(lambda_temp>prctile(lambda_temp,75))  ; % ns vector of lambda_i   
        
end



%lambda_m    =  kron(ones(1,nj),betas(:,1))+kron(ones(1,nj),betas(:,2).*wage);  
lambda_m    =  kron(ones(1,nj),lambda);
ns=size(wage,1);
mgcflow = zeros(nj,1);
mgcbal  = zeros(nj,1);
%Define 10 years out index for annual cost calculation
temp=[1997 1998 1999 2000 2001 2002 2003 2004 2005 2006]-1996;
nt=size(temp,2);   %number of years going out - 10 years amortization %
yrs_to_ret_m=yrs_to_ret*ones(1,nt);   % ns x nt matrix %
yrs_disc=max(yrs_to_ret_m+1-ones(ns,1)*temp,0); % defines the disount level, 0 if you already reached retirement %
                                                % ns x nt matrix of discount levels for each person in each year %
indicator = (yrs_to_ret_m>=ones(ns,1)*temp);  % ns x nt matrix indicating if person i is still non-retired at time t%


capped_salary1     = indicator.*capped_salary; %ns x nt .* ns x nt
temp2     = capped_salary1.*cs_alt;  %ns x nt .* ns x nt.* ns x nt
cs1     = indicator.*cs_alt;


%Generate contribution in each year if no fees: Non-retirement indicator *
%contribution rate* capped salary + cuotasocial plus compound interest
%since no fees, this is the same for all afores. 

contribution2 = sum(( 0.065*capped_salary1+cs1 )  .*  1.025  .*  (1.05.^(yrs_disc-1)),2); % an ns x nt matrix %


[x,y]=meshgrid( 0:.001:.032 , 0.00:.001:.0475);
 n1=length(x(:,1));
 n2=length(x(1,:));
 

 
% Choose which profit function to plot
deletem=ones(nj,1);
deletem(m)=0;
deletem=logical(deletem);
flowfee   = fees(deletem,2)/100;
balancefee = fees(deletem,3)/100;
delta=delta(deletem,:);

% CREATING MATRIX OF FLOW FEES USING ASSUMPTIONS
       flowfeem=zeros(nj-1,nt);   %nafore x nyears to retirement%
       flowfeem(:,1)=flowfee;       %base flow fee in first year%
       for j=2:nt
          flowfeem(:,j)=flowfeem(:,j-1) +delta(:,j);  %replace flow fee in each year with flow fee - tenure discount %
       end
      flowfeem=max(flowfeem,0);  %there shouldn't be any negative flow fees%
          
flowcosts=zeros(ns,nj-1);
balancecosts=zeros(ns,nj-1);
 
% Cost Calculations
       for j=1:nj-1
           yr_contr             = capped_salary1.* (  0.065-kron( ones(ns,1),flowfeem(j,:))  );
           contribution1         = indicator.*(  yr_contr +cs1  )  .* (1+(0.05-balancefee(j))/2) .* (1.05-balancefee(j)).^(yrs_disc-1);
           flowcosts(:,j)        = contribution2-sum(contribution1,2);   
           balancecosts(:,j)     = sar92sum .* (  1.05.^yrs_to_ret- (1.05-balancefee(j)).^yrs_to_ret ); 
      end
       
       
       othercost   = (1/1.05).^repmat(yrs_to_ret,[1 nj-1]).*(flowcosts+balancecosts);
       choosedelta = betas(:,3:end);
       choosedelta = choosedelta(:,deletem);
       othernumerator   = exp( (lambda_m(:,deletem).*othercost + choosedelta) );   %an ns x nj matrix of e^xb for each person i and afore j 
       otherdenominator = sum(othernumerator,2);    % an ns x 1 matirx of sum(e^xb) for each person i 
       owncost=zeros(n1,n2,ns);
       owncontribution1=zeros(n1,n2,ns);
       ownprob=zeros(n1,n2,ns);
       dcostdflow=zeros(n1,n2,ns);
       focflowfee=zeros(n1,n2,ns);
       dcostdbal=zeros(n1,n2,ns);
       focbal=zeros(n1,n2,ns);
       lambdam=zeros(n1,n2,ns);
       
       %Parallel
       parfor j=1:ns
           dcostdbal(:,:,j)= dcostdbal(:,:,j) + sar92sum(j)*yrs_to_ret(j)*(1.05*ones(n1,n2)-y).^(yrs_to_ret(j)-1);
           for t=1:yrs_to_ret(j)
               owncontribution1(:,:,j) = owncontribution1(:,:,j) + indicator(j,t)*( capped_salary1(j,t)*( 0.065*ones(n1,n2)-x) + cs1(j,t)*ones(n1,n2) ).*(1*ones(n1,n2)+ (.05*ones(n1,n2)-y)/2).*(1.05*ones(n1,n2)-y).^(yrs_disc(j,t)-1);
               dcostdflow(:,:,j)       = dcostdflow(:,:,j) + indicator(j,t)*capped_salary1(j,t)*ones(n1,n2).*(1*ones(n1,n2)+ (.05*ones(n1,n2)-y)/2).*(1.05*ones(n1,n2)-y).^(yrs_disc(j,t)-1);
               dcostdbal(:,:,j)        = dcostdbal(:,:,j) + indicator(j,t).*( capped_salary1(j,t)*(0.065*ones(n1,n2)-x) + cs1(j,t) ).*((1*ones(n1,n2)+ (.05*ones(n1,n2)-y)./2).*(1.05*ones(n1,n2)-y).^(yrs_disc(j,t)-2).*ones(n1,n2)*(yrs_disc(j,t)-1) + (1.05*ones(n1,n2)-y).^(yrs_disc(j,t)-1).*ones(n1,n2)./2);
           end
           owncost(:,:,j) = (1/1.05).^yrs_to_ret(j).*(contribution2(j)*ones(n1,n2) - owncontribution1(:,:,j) + sar92sum(j)*(1.05.^yrs_to_ret(j)*ones(n1,n2)-(1.05*ones(n1,n2)-y).^yrs_to_ret(j) ));
           ownprob(:,:,j) = exp( ( lambda(j).*owncost(:,:,j) + betas(j,2+m)*ones(n1,n2)))./ ( otherdenominator(j)*ones(n1,n2)+ exp( (lambda(j).*owncost(:,:,j) + betas(j,2+m)*ones(n1,n2))));
           lambdam(:,:,j)=ones(n1,n2)*lambda(j);
       end
      
       z=sum(ownprob.*owncost,3);
       clear owncontribution owncost ownprob lambdam 
       figure
       surf(x,y,z)
           xlabel('flow fee') % x-axis label
       ylabel('balance fee')
       zlabel('profit') 
       figname = strcat(dirname_output,'/profitXXI_neutral');
       savefig(figname)
       figname = strcat(figname,'.png');
       saveas(gcf,figname)