
% Function used to save using parallel
% Transparency is violated by the SAVE command because in general 
% MATLAB cannot determine which variables from the workspace will be saved to a file.


function parsave(fname, data)

    % Saves file and keeps trying to save if encounters an error, in which
    % case there is a warning.
     saved = 0;
        while saved == 0
            try
                save(fname, 'data')
                saved = 1;
            catch
                warning('Problem saving, retry saving...')
                pause(.5);
            end;
        end;

end