
function precalc_higher(horiz)


global dirname dirname_pre dirname_output flowcap balcap gridsize ns matsize


% Step 1: Set horizon

h=horiz;


% Step 2: initialize worker pool

%matlabpool


% Step 3: create revenue matrices and numerator with baseline advertising

% Step 3.a: Create numerator and revenue for firms with tenure discounts and
% firm 1 

load newdata.mat
tic

for m=1:17
    
    % Calculate for the first 100k
    
    parfor k=1:floor(ns/matsize)
            [m,k,h(m)]
            globalBridge(dirname,dirname_pre,dirname_output,flowcap,balcap,gridsize,ns,matsize);
            index=(k-1)*matsize+1:k*matsize;
            % calculate numerator and owncost (undiscounted revenue)
            numer =calc_numer(index',m,gridsize,flowcap, balcap, 1,matsize,1 );
            parsave(fullfile(dirname_pre...
                ,strcat(num2str(m),'numer',num2str(k))), numer);                          
           
            rev=calc_revenue(index,h(m),matsize,m);   
            parsave(fullfile(dirname_pre...
                ,strcat(num2str(m),'rev'...
                ,num2str(k),'h',num2str(h(m)))), rev);                          
            
            
    end
    
    % Calculate for the last 199 sample
    
      index=floor(ns/matsize)*matsize+1:ns;
    
    numer =calc_numer(index',m,gridsize,flowcap, balcap, 1,ns-floor(ns/matsize)*matsize,1 );
            parsave(fullfile(dirname_pre...
                ,strcat(num2str(m),'numer',num2str(floor(ns/matsize)+1))), numer);                          
            
            
                
                % use owncost to calculate discounted revenue, which depend
                % on firm horizon.
                
     rev=calc_revenue(index,h(m),ns-floor(ns/matsize)*matsize,m);   

    parsave(fullfile(dirname_pre...
            ,strcat(num2str(m),'rev'...
            ,num2str(floor(ns/matsize)+1),'h',num2str(h(m)))), rev);                          
            
           
     
end

% Step 3.b: create numerator with neutral advertising


for m=1:17
    
   parfor k=1:floor(ns/matsize)
         [m,k,h(m)]
          globalBridge(dirname,dirname_pre,dirname_output,flowcap,balcap,gridsize,ns,matsize);
          index=(k-1)*matsize+1:k*matsize;
          % calculate numerator and owncost (undiscounted revenue)  
          numer =calc_numer(index',m,gridsize,flowcap, balcap, 2,matsize ,1);
          parsave(fullfile(dirname_pre...
                ,strcat(num2str(m),'cnumer',num2str(k))), numer);                          
                        
   end
   
   index=floor(ns/matsize)*matsize+1:ns;
   
   numer =calc_numer(index',m,gridsize,flowcap, balcap, 2,ns-floor(ns/matsize)*matsize,1 );
   parsave(fullfile(dirname_pre...
         ,strcat(num2str(m),'cnumer',num2str(floor(ns/matsize)+1))), numer); 
     
end


toc



%matlabpool close
